﻿
//====================================================
// Подробное описание программного кода исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================



[<EntryPoint>]
let main argv =

    // --- Явные свойства ---
    
    let prop = Properties.ExplicitProperties()

    prop.Simple <- "Сегодня хорошая погода!"
    printfn $"%s{prop.Simple}"

    prop.MyProperty <- 2345
    printfn $"prop.MyProperty = %d{prop.MyProperty}"



    (*
    // --- Автоматические свойства ---

    let prop = Properties.AutoProperties()

    printfn $"SimpleAutoProperty=%s{prop.SimpleAutoProperty.Ticks.ToString()}"
    printfn $"SimpleAutoProperty=%s{prop.SimpleAutoProperty.Ticks.ToString()}"
    printfn $""
    prop.SimpleAutoProperty <- System.DateTime.Now
    printfn $"SimpleAutoProperty=%s{prop.SimpleAutoProperty.Ticks.ToString()}"
    printfn $""
    printfn $"SimpleExplicitProperty=%s{prop.SimpleExplicitProperty.Ticks.ToString()}"
    printfn $"SimpleExplicitProperty=%s{prop.SimpleExplicitProperty.Ticks.ToString()}"

    // Инициализация в дополнительном конструкторе
    let prop = Properties.AutoProperties(7)
    printfn $""
    printfn $"SimpleAutoProperty=%s{prop.SimpleAutoProperty.ToString()}"
    *)


    (*
    // --- Статические свойства ---

    printfn $"MyStaticProperty=%f{Properties.StaticProperties.StaticProperty}"
    Properties.StaticProperties.StaticProperty <- 45.32 * 23.8745
    printfn $"MyStaticProperty=%f{Properties.StaticProperties.StaticProperty}"

    // Невозможно изменить свойство только для чтения.
    // Properties.StaticProperties.StaticReadOnly <- 45.7
    printfn $""
    printfn $"%f{Properties.StaticProperties.StaticReadOnly}"
    
    // Статическое авто-свойство для получения информации.
    printfn $""
    printfn $"В текущем месяце - %d{Properties.StaticProperties.StaticAutoProp} дней"
    *)

    
   (*
    // --- Модификаторы доступа ---

    let prop = AccessibilityModifiers.AccessibilityModifier(700)
    // Нельзя изменить значение свойства вне класса.
    //prop.ReadOnlyProperty <- 400
    printfn $"%d{prop.ReadOnlyProperty}"

    let prop = AccessibilityModifiers.AccessibilityModifier(0)
    printfn $"%d{prop.ReadOnlyProperty}"

    // Ошибка	FS0491	
    // Конструктор элемента или объекта "PrivateProperty" не является accessible.
    //prop.PrivateProperty <- 900

    *)



    0 // return an integer exit code
